import { BaseAction, IActionPayload } from './BaseAction';
import { State, StateReturn, BaseModel } from '../models/BaseModel';
export interface IActionNormal<Data = any, Payload = any> extends IActionPayload<Payload> {
    modelName: string;
    effect: (state: State<Data>, action: IActionPayload<Payload>) => StateReturn<Data>;
}
export interface NormalSubscriber<CustomData, Payload> {
    when: string;
    effect: (state: State<CustomData>, action: IActionPayload<Payload>) => StateReturn<CustomData>;
}
export declare const normalActionProxyKeys: {
    methods: (keyof NormalAction<any, any, any>)[];
};
export declare class NormalAction<Data, Callback extends (state: State<Data>, payload: Payload) => StateReturn<Data>, Payload> extends BaseAction<Data> {
    private callback;
    constructor(model: BaseModel<Data>, changeFn: Callback, fromSubClass?: boolean);
    /**
     * @override
     */
    protected getProxyMethods(): string[];
    protected changeCallback(fn: Callback): void;
    onSuccess<CustomData>(effect: NormalSubscriber<CustomData, Payload>['effect']): NormalSubscriber<CustomData, Payload>;
    protected getProxyFn(): Function;
}
