"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NormalAction = exports.normalActionProxyKeys = void 0;
var tslib_1 = require("tslib");
var BaseAction_1 = require("./BaseAction");
var StoreHelper_1 = require("../stores/StoreHelper");
exports.normalActionProxyKeys = {
    methods: tslib_1.__spread(['onSuccess', 'changeCallback'], BaseAction_1.actionProxyKeys.methods),
};
var NormalAction = /** @class */ (function (_super) {
    tslib_1.__extends(NormalAction, _super);
    function NormalAction(model, changeFn, fromSubClass) {
        if (fromSubClass === void 0) { fromSubClass = false; }
        var _this = _super.call(this, model) || this;
        _this.callback = changeFn;
        return fromSubClass ? _this : _this.proxy();
    }
    /**
     * @override
     */
    NormalAction.prototype.getProxyMethods = function () {
        return exports.normalActionProxyKeys.methods;
    };
    NormalAction.prototype.changeCallback = function (fn) {
        this.callback = fn;
    };
    NormalAction.prototype.onSuccess = function (effect) {
        return {
            when: this.getSuccessType(),
            effect: effect,
        };
    };
    NormalAction.prototype.getProxyFn = function () {
        var _this = this;
        var modelName = this.model.getReducerName();
        return function (payload) {
            return StoreHelper_1.storeHelper.dispatch({
                type: _this.getSuccessType(),
                payload: payload,
                modelName: modelName,
                effect: function (state, action) {
                    return _this.callback(state, action.payload);
                },
            });
        };
    };
    return NormalAction;
}(BaseAction_1.BaseAction));
exports.NormalAction = NormalAction;
