import { BaseModel } from './BaseModel';
import { HttpTransform } from '../actions/BaseRequestAction';
import { IActionPayload } from '../actions/BaseAction';
import { IReducers } from '../reducers/BaseReducer';
export interface IMetaAction {
    metaKey: string | number | symbol | boolean;
    metaActionName: string;
}
export declare type MetasLoading<M> = {
    pick: (value: M) => boolean;
};
export declare const DEFAULT_META: Meta;
export declare const METAS_PICK_METHOD: {
    pick: (value: any) => Meta;
};
export declare const DEFAULT_METAS: Metas;
export declare type Meta = Readonly<{
    actionType: string;
    loading: boolean;
} & HttpTransform>;
export declare type Metas<M = any> = Partial<{
    [key: string]: Meta;
}> & {
    pick: (value: M) => Meta;
};
interface Data {
    [key: string]: Metas | Meta;
}
export interface IMetaRestore extends IActionPayload<{
    key: string;
    value: Meta | Metas;
}> {
}
export interface IMetaStash {
    [key: string]: Metas | Meta | '@flus/used';
}
export declare class MetaModel extends BaseModel<Data> {
    private __stash;
    getReducerName(): string;
    register(): IReducers;
    get stash(): IMetaStash;
    protected getMeta<T extends Meta | Metas>(name: string): T | undefined;
    protected initReducer(): Data;
}
export declare const metaModel: MetaModel;
export {};
