import { IResponseAction, BaseRequestAction, IBaseRequestAction } from '../actions/BaseRequestAction';
import { METHOD } from '../utils/method';
declare type Options<Data, Response, Payload> = Partial<Omit<IBaseRequestAction<Data, Response, Payload>, 'type'>> & {
    uri: string;
    instanceName: string;
    method: METHOD;
};
export declare type ThrottleOptionns = {
    duration: number;
    deps?: any[];
    enable?: boolean;
};
export declare class HttpServiceBuilder<Data, Response, Payload = unknown, RequestOption extends object = object, M = true> {
    protected readonly config: Options<Data, Response, Payload>;
    constructor(config: Options<Data, Response, Payload>);
    query(query: object): this;
    body(body: object): this;
    successText(text: string): this;
    failText(text: string): this;
    requestOptions(options: RequestOption): this;
    hideError(is: boolean | ((response: IResponseAction<Response, Payload>) => boolean)): this;
    throttle(options: number | ThrottleOptionns): this;
    payload<T>(payload: T): M extends true ? HttpServiceBuilderWithMeta<Data, Response, T, RequestOption, true> : HttpServiceBuilderWithMetas<Data, Response, T, RequestOption, M>;
    metas(value: string): HttpServiceBuilderWithMetas<Data, Response, Payload, RequestOption, string>;
    metas(value: number): HttpServiceBuilderWithMetas<Data, Response, Payload, RequestOption, number>;
    metas(value: symbol): HttpServiceBuilderWithMetas<Data, Response, Payload, RequestOption, symbol>;
    onPrepare(fn: NonNullable<IBaseRequestAction<Data, Response, Payload>['onPrepare']>): this;
    onSuccess(fn: NonNullable<IBaseRequestAction<Data, Response, Payload>['onSuccess']>): this;
    onFail(fn: NonNullable<IBaseRequestAction<Data, Response, Payload>['onFail']>): this;
    protected collect(instance: BaseRequestAction<Data, any, any, any, any>): IBaseRequestAction<Data, Response, Payload>;
}
export declare class HttpServiceBuilderWithMeta<Data, Response, Payload, RequestOption extends object, M = true> extends HttpServiceBuilder<Data, Response, Payload, RequestOption, M> {
    private readonly _;
}
export declare class HttpServiceBuilderWithMetas<Data, Response, Payload, RequestOption extends object, M> extends HttpServiceBuilder<Data, Response, Payload, RequestOption, M> {
    private readonly _;
}
export {};
